package com.zswl.cloud.springBtach.server.core.service;


import cn.hutool.json.JSONUtil;
import com.github.microservice.auth.security.helper.AuthHelper;
import com.xiaoju.open.oil.commons.config.OilConfig;
import com.xiaoju.open.oil.core.QueryClient;
import com.xiaoju.open.oil.core.QueryClientFactory;
import com.xiaoju.open.oil.core.executor.ResponseDTO;
import com.xiaoju.open.oil.interfaces.request.NotificationPushStoreInfoRequest;
import com.xiaoju.open.oil.interfaces.request.QueryStoreDetailRequest;
import com.xiaoju.open.oil.interfaces.response.QueryStoreDetailResponse;
import com.zswl.cloud.springBtach.server.core.dao.XiaoJuStoreDao;
import com.zswl.cloud.springBtach.server.core.domain.XiaoJuStore;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class XiaoJuService {


    @Autowired
    AuthHelper authHelper;

    @Autowired
    XiaoJuStoreDao xiaoJuStoreDao;

    @Autowired
    OilConfig oilConfig;

    public QueryStoreDetailResponse queryStoreDetail(String storeId) {
        XiaoJuStore byStoreId = xiaoJuStoreDao.findByStoreId(storeId);
        QueryStoreDetailRequest queryStoreDetailRequest = new QueryStoreDetailRequest();

        queryStoreDetailRequest.setOutUserId(authHelper.getCurrentUser().getUserId());
        queryStoreDetailRequest.setStoreId(storeId);
        queryStoreDetailRequest.setLat(byStoreId.getLat());
        queryStoreDetailRequest.setLon(byStoreId.getLon());
        queryStoreDetailRequest.setOpenChannel(1);

        QueryClient queryClient = QueryClientFactory.create(oilConfig);

        QueryStoreDetailResponse queryStoreDetailResponse = queryClient.api().queryStoreDetail(queryStoreDetailRequest);

        return queryStoreDetailResponse;
    }





    public ResponseDTO notificationPushStoreInfoRequest(NotificationPushStoreInfoRequest notificationPushStoreInfoRequest){

        XiaoJuStore xiaoJuStore = new XiaoJuStore();
        BeanUtils.copyProperties(notificationPushStoreInfoRequest, xiaoJuStore);
        xiaoJuStore.setItemInfoList(JSONUtil.parseObj(notificationPushStoreInfoRequest.getItemInfoList()));
        xiaoJuStoreDao.save(xiaoJuStore);
        ResponseDTO responseDTO = new ResponseDTO();

        responseDTO.setAppKey(oilConfig.getAppKey());
        responseDTO.setCode("0");
        responseDTO.setMsg("请求成功");
        responseDTO.setData("heO67plAls2+P9bo/7XJnHz77N8W+WyCP37/COPLr3k=");
        responseDTO.setSig("B1445B2A12037FADFCD6FAE6D83ECB9A");

        return responseDTO;





    }





}
